'ImageMenuItem Class for VB.NET
'Version 1.1
'Copyright 2003-2005 DOBON! All rights reserved.
'쐬ҁAҁFǂڂI http://dobon.net
'i͍̕폜ȂłBj

Imports System
Imports System.ComponentModel
Imports System.Drawing
Imports System.Drawing.Text
Imports System.Drawing.Imaging
Imports System.Windows.Forms
Imports System.Drawing.Drawing2D

Namespace Dobon.Samples.Controls
    ''' <summary>
    ''' j[ڂɃACRi摜j\邽߂̃NX
    ''' </summary>
    Public Class ImageMenuItem
        Inherits MenuItem

        '萔-----------------------------------------
        '\摜̃TCY
        Private Const imageHeight As Integer = 16
        Private Const imageWidth As Integer = 16
        '̗]i̗]ɂȂj
        Private Const topMargin As Integer = 1
        '̗]
        Private Const leftMargin As Integer = 2
        '摜ƃeLXg̊Ԋu
        Private Const intervalImageAndText As Integer = 4
        'E̗]
        Private Const rightMargin As Integer = 20
        'j[̃eLXg̕\ʒu
        Private Const textLeft As Integer = leftMargin + imageWidth + intervalImageAndText
        'eLXgȊO̕̕
        Private Const widthExceptText As Integer = imageWidth + leftMargin + intervalImageAndText + rightMargin
        'Office97 StylêƂ̑IF̕`Jnʒu(XW)
        Private Const selectedColorLeft As Integer = leftMargin * 2 + imageWidth

        'vpeB-----------------------------------
        Private _image As Image
        ''' <summary>
        ''' \摜
        ''' </summary>
        Public Property Image() As Image
            Get
                Return _image
            End Get
            Set(ByVal Value As Image)
                If Not (_disabledImage Is Nothing) Then
                    _disabledImage.Dispose()
                    _disabledImage = Nothing
                End If
                _image = Value
            End Set
        End Property

        Private _disabledImage As Image
        Private ReadOnly Property DisabledImage() As Image
            Get
                If _disabledImage Is Nothing Then
                    _disabledImage = CreateDisabledImage(_image)
                End If
                Return _disabledImage
            End Get
        End Property

        Public Enum MenuStyle
            Normal
            Office97
        End Enum
        Private _menuStyle As MenuStyle
        ''' <summary>
        ''' j[̃X^C
        ''' </summary>
        Public Property Style() As MenuStyle
            Get
                Return _menuStyle
            End Get
            Set(ByVal Value As MenuStyle)
                _menuStyle = Value
            End Set
        End Property

        'RXgN^-------------------------------
        Public Sub New(ByVal [text] As String)
            MyBase.New([text])
            Me.OwnerDraw = True
            Me._menuStyle = MenuStyle.Office97
        End Sub

        '\bh-------------------------------------
        Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
            If Not (_disabledImage Is Nothing) Then
                _disabledImage.Dispose()
                _disabledImage = Nothing
            End If
            MyBase.Dispose(disposing)
        End Sub

        ''' <summary>
        ''' OnMeasureItem̃I[o[Ch
        ''' j[ACȇ傫vZ
        ''' "e.ItemHeight"ɕ"e.ItemWidth"ɓ
        ''' </summary>
        ''' <param name="e"></param>
        Protected Overrides Sub OnMeasureItem(ByVal e As MeasureItemEventArgs)
            '{NXOnMeasureItem
            MyBase.OnMeasureItem(e)

            'j[ɕ\镶擾
            Dim menuText As String
            menuText = [Text]
            'V[gJbg\Ƃ́A̕ǉ
            If ShowShortcut = True And Shortcut <> Shortcut.None Then
                menuText += TypeDescriptor.GetConverter(GetType(Keys)).ConvertToString(CType(Shortcut, Keys))
            End If

            Dim sf As New StringFormat
            'zbgL[vtBbNX̕\(&_ɂ)
            sf.HotkeyPrefix = HotkeyPrefix.Show

            '肷
            e.ItemWidth = CInt(e.Graphics.MeasureString(menuText, SystemInformation.MenuFont, Integer.MaxValue, sf).Width) + widthExceptText
            '\[XJ
            sf.Dispose()

            '肷
            e.ItemHeight = Math.Max(SystemInformation.MenuFont.Height, imageHeight) + topMargin * 2
        End Sub

        ''' <summary>
        ''' OnDrawItem̃I[o[Ch
        ''' j[ڂ`悷
        ''' </summary>
        ''' <param name="e"></param>
        Protected Overrides Sub OnDrawItem(ByVal e As DrawItemEventArgs)
            Dim textColor As Color

            '{NXOnDrawItem
            MyBase.OnDrawItem(e)

            If (e.State And DrawItemState.Disabled) <> 0 Then
                'Ԃ̎
                'wihԂ
                e.Graphics.FillRectangle(SystemBrushes.Menu, e.Bounds)
                '̕`ɎgpFw
                textColor = SystemColors.ControlDark
            ElseIf (e.State And DrawItemState.Selected) = 0 Then
                'IĂȂ
                'wihԂ
                e.Graphics.FillRectangle(SystemBrushes.Menu, e.Bounds)
                '̕`ɎgpFw
                textColor = SystemColors.MenuText
            Else
                'IĂ鎞
                'wihԂ
                If _menuStyle = MenuStyle.Normal Or (_image Is Nothing And Not Checked) Then
                    e.Graphics.FillRectangle(SystemBrushes.Highlight, e.Bounds)
                Else
                    e.Graphics.FillRectangle(SystemBrushes.Highlight, selectedColorLeft, e.Bounds.Top, e.Bounds.Width - selectedColorLeft, e.Bounds.Height)
                End If
                '̕`ɎgpuV̍쐬
                textColor = SystemColors.HighlightText
            End If

            '摜̕`
            '`ʒǔ
            Dim imagePoint As New Point
            imagePoint.X = e.Bounds.Left + leftMargin
            imagePoint.Y = e.Bounds.Top + (e.Bounds.Height - imageHeight) / 2
            '`
            If (e.State And DrawItemState.Checked) <> 0 Then
                '`FbNtĂƂ̓`FbN`
                DrawMenuCheckmark(e, RadioCheck, textColor, imagePoint.X, imagePoint.Y)
            Else
                '摜̕`
                If Not (_image Is Nothing) Then
                    DrawMenuImage(e, _image, imagePoint.X, imagePoint.Y)
                End If
            End If

            '̕`̏
            Dim sf As New StringFormat
            'zbgL[vtBbNX̕\(&A_[Cɂ)
            sf.HotkeyPrefix = HotkeyPrefix.Show

            'Text̕\ʒu肷
            Dim textPosition As New PointF
            textPosition.X = e.Bounds.Left + textLeft
            textPosition.Y = e.Bounds.Top + (e.Bounds.Height - SystemInformation.MenuFont.Height) / 2

            'Text̕`
            Dim textBrush As Brush
            textBrush = New SolidBrush(textColor)
            DrawMenuText(e, [Text], textBrush, textPosition, sf)

            'Shortcut`
            If ShowShortcut = True And Shortcut <> Shortcut.None Then
                'Shortcut̕擾
                Dim shortcutText As String = TypeDescriptor.GetConverter(GetType(Keys)).ConvertToString(CType(Shortcut, Keys))
                'Shortcut̕擾
                Dim shortcutWidth As Integer = CInt(e.Graphics.MeasureString(shortcutText, SystemInformation.MenuFont, Integer.MaxValue, sf).Width)
                'Shortcut̕\ʒu肷
                Dim shortcutPosition As New PointF
                shortcutPosition.X = e.Bounds.Right - shortcutWidth - rightMargin
                shortcutPosition.Y = textPosition.Y
                'Shortcut̕`
                DrawMenuText(e, shortcutText, textBrush, shortcutPosition, sf)
            End If

            '\[XJ
            textBrush.Dispose()
            sf.Dispose()
        End Sub

        ''' <summary>
        ''' ̕`
        ''' </summary>
        ''' <param name="e">`DrawItemEventArgs</param>
        ''' <param name="text">`悷镶</param>
        ''' <param name="textBrush">`ɎgpuV</param>
        ''' <param name="point">`ʒu</param>
        ''' <param name="sf"></param>
        Private Shared Sub DrawMenuText(ByVal e As DrawItemEventArgs, ByVal [text] As String, ByVal textBrush As Brush, ByVal point As PointF, ByVal sf As StringFormat)
            If (e.State And DrawItemState.Disabled) <> 0 Then
                'Ԃ̂Ƃ͉e`悷
                e.Graphics.DrawString([text], SystemInformation.MenuFont, SystemBrushes.ControlLightLight, point.X + 1, point.Y + 1, sf)
            End If

            '̕`
            e.Graphics.DrawString([text], SystemInformation.MenuFont, textBrush, point, sf)
        End Sub

        ''' <summary>
        ''' 摜̕`
        ''' </summary>
        ''' <param name="e">`DrawItemEventArgs</param>
        ''' <param name="img">`悷摜</param>
        ''' <param name="x">`悷ʒu</param>
        ''' <param name="y">`悷ʒu</param>
        Private Sub DrawMenuImage(ByVal e As DrawItemEventArgs, ByVal img As Image, ByVal x As Integer, ByVal y As Integer)

            If (e.State And DrawItemState.Disabled) = 0 Then
                'LԂ̎
                If _menuStyle = MenuStyle.Office97 And (e.State And DrawItemState.Selected) <> 0 Then
                    'g`
                    DrawImageFrame(e, x, y, False)
                End If
                e.Graphics.DrawImage(img, x, y, imageWidth, imageHeight)
            Else
                'Ԃ̎
                e.Graphics.DrawImage(DisabledImage, x, y, imageWidth + 1, imageHeight + 1)
            End If
        End Sub

        ''' <summary>
        ''' Ԃ̉摜쐬
        ''' </summary>
        ''' <param name="img">ɂȂ摜</param>
        Private Shared Function CreateDisabledImage(ByVal img As Image) As Image
            If img Is Nothing Then
                Return Nothing
            End If

            'Ԃ̉摜 ̉摜c1hbg傫Ȃ
            Dim dbmp As New Bitmap(img.Width + 1, img.Height + 1)
            'Ƃ̉摜
            Dim bmp As New Bitmap(img)

            '1hbgׂ
            Dim y As Integer
            For y = 0 To bmp.Height - 1
                Dim x As Integer
                For x = 0 To bmp.Width - 1
                    '̐FA邢F𓧖ɂ
                    If bmp.GetPixel(x, y).A = &HFF And bmp.GetPixel(x, y).GetBrightness() < 1.0F Then
                        dbmp.SetPixel(x, y, SystemColors.ControlDark)
                        dbmp.SetPixel(x + 1, y + 1, SystemColors.ControlLightLight)
                    End If
                Next x
            Next y

            bmp.Dispose()
            Return dbmp
        End Function

        ''' <summary>
        ''' j[̃`FbN}[N̕`
        ''' </summary>
        ''' <param name="e">`DrawItemEventArgs</param>
        ''' <param name="radio">Radio Button`悷邩</param>
        ''' <param name="foreColor">OiF</param>
        ''' <param name="x">`悷ʒu</param>
        ''' <param name="y">`悷ʒu</param>
        Private Sub DrawMenuCheckmark(ByVal e As DrawItemEventArgs, ByVal radio As Boolean, ByVal foreColor As Color, ByVal x As Integer, ByVal y As Integer)
            If _menuStyle = MenuStyle.Normal Then
                'VBitmapIuWFNg̍쐬
                Dim bmp As New Bitmap(imageWidth, imageHeight)
                Dim bmpg As Graphics = Graphics.FromImage(bmp)

                '쐬BitmapIuWFNgɃ`FbN}[N`
                ControlPaint.DrawMenuGlyph(bmpg, 0, 0, imageWidth, imageHeight, IIf(radio, MenuGlyph.Bullet, MenuGlyph.Checkmark))

                If (e.State And DrawItemState.Disabled) <> 0 Then
                    'Ԃ̂Ƃ͉e`悷
                    'ImageAttributesw肵ĕ`
                    e.Graphics.DrawImage(bmp, New Rectangle(x + 1, y + 1, bmp.Width, bmp.Height), 0, 0, bmp.Width, bmp.Height, GraphicsUnit.Pixel, CreateImageAttributes(SystemColors.ControlLightLight))
                End If

                'ImageAttributesw肵ĕ`
                e.Graphics.DrawImage(bmp, New Rectangle(x, y, bmp.Width, bmp.Height), 0, 0, bmp.Width, bmp.Height, GraphicsUnit.Pixel, CreateImageAttributes(foreColor))

                bmpg.Dispose()
                bmp.Dispose()
            Else
                'Office97X^C
                'g`
                DrawImageFrame(e, x, y, True)

                'wih
                Dim backBrush As Brush
                If (e.State And DrawItemState.Selected) = 0 Or Not Enabled Then
                    backBrush = New HatchBrush(HatchStyle.Percent50, SystemColors.Menu, SystemColors.ControlLightLight)
                Else
                    backBrush = New SolidBrush(SystemColors.Menu)
                End If
                e.Graphics.FillRectangle(backBrush, x, y, imageWidth, imageHeight)
                backBrush.Dispose()

                If _image Is Nothing Then
                    '`FbN}[N̕`
                    DrawOffice97Checkmark(e.Graphics, radio, x, y, Not Enabled)
                Else
                    '摜̕`
                    e.Graphics.DrawImage(_image, x, y, imageWidth, imageHeight)
                End If
            End If
        End Sub

        ''' <summary>
        ''' w肵FŁA𓧖Fɒu
        ''' </summary>
        ''' <param name="foreColor">ƓւF</param>
        Private Shared Function CreateImageAttributes(ByVal foreColor As Color) As ImageAttributes
            'Fւ邽߂̏
            Dim cms() As ColorMap = {New ColorMap, New ColorMap}
            'ւFw肷
            cms(0).OldColor = Color.Black
            cms(0).NewColor = foreColor
            cms(1).OldColor = Color.White
            cms(1).NewColor = Color.Transparent
            'ImageAttributesIuWFNg̍쐬
            Dim imageAttr As New ImageAttributes
            imageAttr.SetRemapTable(cms)
            'lԂ
            Return imageAttr
        End Function

        ''' <summary>
        ''' Office97^CṽACR̘g`悷
        ''' </summary>
        ''' <param name="e">`DrawItemEventArgs</param>
        ''' <param name="x">ACRXW</param>
        ''' <param name="y">ACRYW</param>
        ''' <param name="down">E񂾘g`</param>
        Private Shared Sub DrawImageFrame(ByVal e As DrawItemEventArgs, ByVal x As Integer, ByVal y As Integer, ByVal down As Boolean)
            'y̌
            Dim p1, p2 As Pen
            If Not down Then
                p1 = SystemPens.ControlLightLight
                p2 = SystemPens.ControlDark
            Else
                p1 = SystemPens.ControlDark
                p2 = SystemPens.ControlLightLight
            End If

            e.Graphics.DrawLines(p1, New Point() {New Point(x - 1, y + imageHeight - 1), New Point(x - 1, y - 1), New Point(x + imageWidth - 1, y - 1)})
            e.Graphics.DrawLines(p2, New Point() {New Point(x - 1, y + imageHeight), New Point(x + imageWidth, y + imageHeight), New Point(x + imageWidth, y - 1)})
        End Sub

        ''' <summary>
        ''' Office97^Cṽ`FbN}[N`悷
        ''' </summary>
        ''' <param name="g">`Graphics</param>
        ''' <param name="radio">RADIO}[N</param>
        ''' <param name="x">ACRXW</param>
        ''' <param name="y">ACRYW</param>
        ''' <param name="disabled">Ԃ</param>
        Private Shared Sub DrawOffice97Checkmark(ByVal g As Graphics, ByVal radio As Boolean, ByVal x As Integer, ByVal y As Integer, ByVal disabled As Boolean)
            g.SetClip(New Rectangle(x, y, imageWidth, imageHeight))
            g.TranslateTransform(x + (imageWidth - 16), y + (imageHeight - 16))

            If Not radio Then
                Dim halfDark As Color = _
                    Color.FromArgb( _
                    (CInt(SystemColors.ControlLightLight.R) + CInt(SystemColors.ControlDark.R)) / 2, _
                    (CInt(SystemColors.ControlLightLight.G) + CInt(SystemColors.ControlDark.G)) / 2, _
                    (CInt(SystemColors.ControlLightLight.B) + CInt(SystemColors.ControlDark.B)) / 2)
                Dim halfDarkPen As New Pen(halfDark)

                Dim darkLine() As Point = {New Point(4, 6), New Point(6, 8), New Point(10, 4)}
                Dim light2Line() As Point = {New Point(3, 7), New Point(3, 8), New Point(6, 11), New Point(11, 6), New Point(11, 5)}
                Dim foreLine1() As Point = {New Point(4, 7), New Point(6, 9), New Point(10, 5)}
                Dim foreLine2() As Point = {New Point(4, 8), New Point(6, 10), New Point(10, 6)}

                If Not disabled Then
                    g.DrawLines(halfDarkPen, darkLine)
                    g.DrawLines(SystemPens.MenuText, foreLine1)
                    g.DrawLines(SystemPens.MenuText, foreLine2)
                    g.DrawLines(SystemPens.ControlLightLight, light2Line)
                Else
                    g.DrawLines(SystemPens.ControlDark, foreLine1)
                    g.DrawLines(SystemPens.ControlDark, foreLine2)
                    g.DrawLines(SystemPens.ControlLightLight, light2Line)
                End If

                halfDarkPen.Dispose()
            Else
                'RADIO}[N̎
                Dim foreColor As Color
                If Not disabled Then
                    foreColor = SystemColors.MenuText
                Else
                    foreColor = SystemColors.ControlDark
                End If

                Dim forePen As New Pen(foreColor)
                Dim foreBrush As New SolidBrush(foreColor)

                g.DrawLine(forePen, New Point(6, 5), New Point(9, 5))
                g.FillRectangle(foreBrush, 5, 6, 6, 4)
                g.DrawLine(forePen, New Point(6, 10), New Point(9, 10))

                forePen.Dispose()
                foreBrush.Dispose()
            End If

            g.ResetTransform()
            g.ResetClip()
        End Sub
    End Class
End Namespace